function [PSSP,x]=partial_coherence(signal,d,f_centrale,var_fase)
%
% Metodo MUSIC per la stima della direzione di arrivo
%      
%      var_fase    <- varianza di fase fra i sensori 
%      r           <- dati dell'array lineare uniforme
%      d           <- numero delle sorgenti
%      delta       <- spaziatura fra i sensori
%      plot pssp   

[m,N]=size(signal);

% calcolo della matrice di covarianza campionata
R=signal*signal'/N;

B=B_matrix(m,var_fase);

% matrice di covarianza in parziale coerenza spaziale
P=B.*R;

passo=0.2;

c=3e8;

naz=round(180/passo);

[U,D,V]=svd(P);

delta=spaziatura(f_centrale);

for ia=1:naz

Az=(ia-1-naz/2)*passo;

psi=[0:m-1]*2*pi*f_centrale*(delta/c)*sin(pi*Az/180);

a_theta=exp(-j*psi');

%calcolo della potenza del pseudo-spettro

sum=0;

for k=d+1:m
sum=sum+(abs(a_theta'*U(:,k)))^2;
end

pssp(ia)=1/sum;

end

PSSP=10*log10(pssp);
figure(1)
x=([1:naz]-1-naz/2)*passo;

plot(x(1:180),PSSP(1:180));
plot(x,PSSP,'r');
title('MUSIC partial spatial coherence');

xlabel('angoli di incidenza in gradi')

ylabel('pseudospettro MUSIC(dB)') 
