function [tau,PSD1,PSD2,frequency1,frequency2]=calcolaTAU(fc,f_tap,banda,num_tap)
% fc=frequenza di campionamento.
% tau=calcolo delle potenze dei segnali nelle varie sottobande.
sottobanda=banda/num_tap;
tau=zeros(2,length(f_tap));

[bits,DScode,Stx,ref]=cp0202_transmitter_2PAM_DS;
% Stx  una matrice con righe pari al numero di segnali UWB
% ortogonali considerati.

% calcolo, per ogni segnale UWB, delle PSD. 
[PSD1,df1,frequency1]=cp0301_PSD(Stx(1,:),fc);

[PSD2,df2,frequency2]=cp0301_PSD(Stx(2,:),fc);

for i=1:length(f_tap)
    
    % indice della PSD corrispondente all'i-esima f_tap.
    indElPSD1=floor((length(PSD1)/fc)*f_tap(i))+length(PSD1)/2;
    
    % calcolo della potenza normalizzata.
    tau(1,i)=(PSD1(indElPSD1)/max(PSD1))*sottobanda;
    
end
    
for i=1:length(f_tap)
    
    indElPSD2=floor((length(PSD2)/fc)*f_tap(i))+length(PSD2)/2;
    
    tau(2,i)=(PSD2(indElPSD2)/max(PSD2))*sottobanda;
    
end

    
    
    
    